/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package view;

import controller.ClientController;
import controller.EmployeeController;
import controller.ProductController;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import model.Client;
import model.Dish;
import model.Employee;
import model.Product;

/**
 *
 * @author cienth
 */
public class EmployeeWorkSystem extends javax.swing.JFrame {

    /**
     * Creates new form EmployeeWorkSystem
     */
    
    private Client client;
    private Product product;
    private static Employee employeeLogged;
    private EmployeeController employeeControlled;
    private final ClientController clientControlled = new ClientController();
    private final ProductController productControlled = new ProductController();
    private ArrayList<Product> orderList = new ArrayList<>();
    
    public EmployeeWorkSystem(Employee e) {
        EmployeeWorkSystem.employeeLogged = e;
       
        initComponents();
       // this.loadTableClientList();
       
       client = null;
       product = null;
       loadTableClientList();
       loadTableOrder();
       loadTableProductList();
       this.ableFields(false);
    }

    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane4 = new javax.swing.JScrollPane();
        jTableClientList = new javax.swing.JTable();
        jTabbedWorkSystem = new javax.swing.JTabbedPane();
        jPanelNewOrder = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldOrderName = new javax.swing.JTextField();
        jTextFieldOrderPhone = new javax.swing.JTextField();
        jButtonOrderEdit = new javax.swing.JButton();
        jButtonOrderSave = new javax.swing.JButton();
        jButtonRemove = new javax.swing.JButton();
        jButtonRemove = new javax.swing.JButton();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTableDishesOrder = new javax.swing.JTable();
        jScrollPane10 = new javax.swing.JScrollPane();
        jTableDrinksOrder = new javax.swing.JTable();
        jScrollPane11 = new javax.swing.JScrollPane();
        jTableDessertsOrder = new javax.swing.JTable();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTableOrder = new javax.swing.JTable();
        jButtonAddToOrder = new javax.swing.JButton();
        jLabelOrderResume = new javax.swing.JLabel();
        jPanelProductManagement = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTableDishes = new javax.swing.JTable();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTableDrinks = new javax.swing.JTable();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTableDesserts = new javax.swing.JTable();
        jButtonNewProduct = new javax.swing.JButton();
        jButtonEditProduct = new javax.swing.JButton();
        jButtonRemove = new javax.swing.JButton();
        jButtonRemoveProduct = new javax.swing.JButton();
        jButtonNewClient = new javax.swing.JButton();
        jTextFieldSearchClient = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jButtonRootMode = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Welcome," + employeeLogged.getName());
        setName("mainFrame"); // NOI18N

        jTableClientList.setModel(new javax.swing.table.DefaultTableModel
            (
                null,
                new String [] {
                    "Name"
                }
            )
            {
                @Override
                public boolean isCellEditable(int rowIndex, int mColIndex) {
                    return false;
                }
            });
            jTableClientList.addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent evt) {
                    jTableClientListMouseClicked(evt);
                }
            });
            jScrollPane4.setViewportView(jTableClientList);

            jLabel2.setText("Cliente:");

            jLabel3.setText("Telefone:");

            jTextFieldOrderName.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jTextFieldOrderNameActionPerformed(evt);
                }
            });

            jButtonOrderEdit.setText("Editar ");
            jButtonOrderEdit.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jButtonOrderEditActionPerformed(evt);
                }
            });

            jButtonOrderSave.setText("Salvar");
            jButtonOrderSave.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jButtonOrderSaveActionPerformed(evt);
                }
            });

            jButtonRemove.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jButtonRemoveActionPerformed(evt);
                }
            });

            jTableDishesOrder.setModel(new javax.swing.table.DefaultTableModel
                (
                    null,
                    new String [] {
                        "Name"
                    }
                )
                {
                    @Override
                    public boolean isCellEditable(int rowIndex, int mColIndex) {
                        return false;
                    }
                });
                jTableDishesOrder.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                jTableDishesOrder.addMouseListener(new java.awt.event.MouseAdapter() {
                    public void mouseClicked(java.awt.event.MouseEvent evt) {
                        jTableDishesOrderMouseClicked(evt);
                    }
                });
                jScrollPane6.setViewportView(jTableDishesOrder);

                jTableDrinksOrder.setModel(new javax.swing.table.DefaultTableModel
                    (
                        null,
                        new String [] {
                            "Name"
                        }
                    )
                    {
                        @Override
                        public boolean isCellEditable(int rowIndex, int mColIndex) {
                            return false;
                        }
                    });
                    jTableDrinksOrder.addMouseListener(new java.awt.event.MouseAdapter() {
                        public void mouseClicked(java.awt.event.MouseEvent evt) {
                            jTableDrinksOrderMouseClicked(evt);
                        }
                    });
                    jScrollPane10.setViewportView(jTableDrinksOrder);

                    jTableDessertsOrder.setModel(new javax.swing.table.DefaultTableModel
                        (
                            null,
                            new String [] {
                                "Name"
                            }
                        )
                        {
                            @Override
                            public boolean isCellEditable(int rowIndex, int mColIndex) {
                                return false;
                            }
                        });
                        jTableDessertsOrder.addMouseListener(new java.awt.event.MouseAdapter() {
                            public void mouseClicked(java.awt.event.MouseEvent evt) {
                                jTableDessertsOrderMouseClicked(evt);
                            }
                        });
                        jScrollPane11.setViewportView(jTableDessertsOrder);

                        jLabel7.setText("Prato Principal:");

                        jLabel8.setText("Bebidas:");

                        jLabel9.setText("Sobremesas:");

                        jTableOrder.setModel(new javax.swing.table.DefaultTableModel
                            (
                                null,
                                new String [] {
                                    "Type", "Name", "Price"
                                }
                            )
                            {
                                @Override
                                public boolean isCellEditable(int rowIndex, int mColIndex) {
                                    return false;
                                }
                            });
                            jTableOrder.addMouseListener(new java.awt.event.MouseAdapter() {
                                public void mouseClicked(java.awt.event.MouseEvent evt) {
                                    jTableOrderMouseClicked(evt);
                                }
                            });
                            jScrollPane7.setViewportView(jTableOrder);

                            jButtonAddToOrder.setText("ADD");
                            jButtonAddToOrder.addActionListener(new java.awt.event.ActionListener() {
                                public void actionPerformed(java.awt.event.ActionEvent evt) {
                                    jButtonAddToOrderActionPerformed(evt);
                                }
                            });

                            jLabelOrderResume.setText("Pedidos feitos:");

                            javax.swing.GroupLayout jPanelNewOrderLayout = new javax.swing.GroupLayout(jPanelNewOrder);
                            jPanelNewOrder.setLayout(jPanelNewOrderLayout);
                            jPanelNewOrderLayout.setHorizontalGroup(
                                jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                            .addContainerGap()
                                            .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                                    .addComponent(jLabel2)
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                    .addComponent(jTextFieldOrderName)
                                                    .addGap(18, 18, 18)
                                                    .addComponent(jLabel3)
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                    .addComponent(jTextFieldOrderPhone, javax.swing.GroupLayout.PREFERRED_SIZE, 260, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelNewOrderLayout.createSequentialGroup()
                                                    .addGap(0, 0, Short.MAX_VALUE)
                                                    .addComponent(jButtonRemove, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                    .addComponent(jButtonOrderSave, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                    .addComponent(jButtonOrderEdit, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jLabel7)
                                                        .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGap(18, 18, 18)
                                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jScrollPane10, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addComponent(jLabel8))
                                                    .addGap(18, 18, 18)
                                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jLabel9)
                                                        .addComponent(jScrollPane11, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGap(0, 0, Short.MAX_VALUE))
                                                .addComponent(jScrollPane7, javax.swing.GroupLayout.Alignment.TRAILING)))
                                        .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                            .addGap(296, 296, 296)
                                            .addComponent(jButtonAddToOrder, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addGap(0, 0, Short.MAX_VALUE))
                                        .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                            .addContainerGap()
                                            .addComponent(jLabelOrderResume, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                    .addContainerGap())
                            );
                            jPanelNewOrderLayout.setVerticalGroup(
                                jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanelNewOrderLayout.createSequentialGroup()
                                    .addGap(22, 22, 22)
                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jLabel2)
                                        .addComponent(jTextFieldOrderName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jLabel3)
                                        .addComponent(jTextFieldOrderPhone, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGap(7, 7, 7)
                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jButtonRemove)
                                        .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jButtonOrderSave)
                                            .addComponent(jButtonOrderEdit)))
                                    .addGap(18, 18, 18)
                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jLabel7)
                                        .addComponent(jLabel8)
                                        .addComponent(jLabel9))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addGroup(jPanelNewOrderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(jScrollPane10, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                                        .addComponent(jScrollPane6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                                        .addComponent(jScrollPane11, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGap(18, 18, 18)
                                    .addComponent(jButtonAddToOrder)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabelOrderResume)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(jScrollPane7, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGap(71, 71, 71))
                            );

                            jTabbedWorkSystem.addTab("Pedidos", jPanelNewOrder);

                            jTableDishes.setModel(new javax.swing.table.DefaultTableModel
                                (
                                    null,
                                    new String [] {
                                        "Name", "in Stock"
                                    }
                                )
                                {
                                    @Override
                                    public boolean isCellEditable(int rowIndex, int mColIndex) {
                                        return false;
                                    }
                                });
                                jTableDishes.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                                jTableDishes.addMouseListener(new java.awt.event.MouseAdapter() {
                                    public void mouseClicked(java.awt.event.MouseEvent evt) {
                                        jTableDishesMouseClicked(evt);
                                    }
                                });
                                jScrollPane5.setViewportView(jTableDishes);

                                jLabel4.setText("Prato Principal:");

                                jLabel5.setText("Bebidas:");

                                jLabel6.setText("Sobremesas:");

                                jTableDrinks.setModel(new javax.swing.table.DefaultTableModel
                                    (
                                        null,
                                        new String [] {
                                            "Name", "in Stock"
                                        }
                                    )
                                    {
                                        @Override
                                        public boolean isCellEditable(int rowIndex, int mColIndex) {
                                            return false;
                                        }
                                    });
                                    jTableDrinks.addMouseListener(new java.awt.event.MouseAdapter() {
                                        public void mouseClicked(java.awt.event.MouseEvent evt) {
                                            jTableDrinksMouseClicked(evt);
                                        }
                                    });
                                    jScrollPane8.setViewportView(jTableDrinks);

                                    jTableDesserts.setModel(new javax.swing.table.DefaultTableModel
                                        (
                                            null,
                                            new String [] {
                                                "Name", "in Stock"
                                            }
                                        )
                                        {
                                            @Override
                                            public boolean isCellEditable(int rowIndex, int mColIndex) {
                                                return false;
                                            }
                                        });
                                        jTableDesserts.addMouseListener(new java.awt.event.MouseAdapter() {
                                            public void mouseClicked(java.awt.event.MouseEvent evt) {
                                                jTableDessertsMouseClicked(evt);
                                            }
                                        });
                                        jScrollPane9.setViewportView(jTableDesserts);

                                        jButtonNewProduct.setText("Novo");
                                        jButtonNewProduct.addActionListener(new java.awt.event.ActionListener() {
                                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                                jButtonNewProductActionPerformed(evt);
                                            }
                                        });

                                        jButtonEditProduct.setText("Editar");
                                        jButtonEditProduct.addActionListener(new java.awt.event.ActionListener() {
                                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                                jButtonEditProductActionPerformed(evt);
                                            }
                                        });

                                        jButtonRemoveProduct.addActionListener(new java.awt.event.ActionListener() {
                                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                                jButtonRemoveProductActionPerformed(evt);
                                            }
                                        });

                                        javax.swing.GroupLayout jPanelProductManagementLayout = new javax.swing.GroupLayout(jPanelProductManagement);
                                        jPanelProductManagement.setLayout(jPanelProductManagementLayout);
                                        jPanelProductManagementLayout.setHorizontalGroup(
                                            jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanelProductManagementLayout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(jLabel4)
                                                    .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addGap(18, 18, 18)
                                                .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanelProductManagementLayout.createSequentialGroup()
                                                        .addComponent(jButtonNewProduct, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addGap(18, 18, 18)
                                                        .addComponent(jButtonEditProduct, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addGap(18, 18, 18)
                                                        .addComponent(jButtonRemoveProduct, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(jPanelProductManagementLayout.createSequentialGroup()
                                                        .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addComponent(jScrollPane8, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                            .addComponent(jLabel5))
                                                        .addGap(18, 18, 18)
                                                        .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addComponent(jLabel6)
                                                            .addComponent(jScrollPane9, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                        );
                                        jPanelProductManagementLayout.setVerticalGroup(
                                            jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanelProductManagementLayout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                    .addComponent(jLabel4)
                                                    .addComponent(jLabel5)
                                                    .addComponent(jLabel6))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                    .addComponent(jScrollPane8)
                                                    .addComponent(jScrollPane5)
                                                    .addComponent(jScrollPane9))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 145, Short.MAX_VALUE)
                                                .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(jPanelProductManagementLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(jButtonNewProduct)
                                                        .addComponent(jButtonEditProduct))
                                                    .addComponent(jButtonRemoveProduct))
                                                .addContainerGap())
                                        );

                                        jTabbedWorkSystem.addTab("Estoque", jPanelProductManagement);

                                        jButtonNewClient.setText("Add Cliente");
                                        jButtonNewClient.addActionListener(new java.awt.event.ActionListener() {
                                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                                jButtonNewClientActionPerformed(evt);
                                            }
                                        });

                                        jLabel1.setText("Procurar:");

                                        jButtonRootMode.addActionListener(new java.awt.event.ActionListener() {
                                            public void actionPerformed(java.awt.event.ActionEvent evt) {
                                                jButtonRootModeActionPerformed(evt);
                                            }
                                        });

                                        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
                                        getContentPane().setLayout(layout);
                                        layout.setHorizontalGroup(
                                            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addGap(0, 0, Short.MAX_VALUE)
                                                        .addComponent(jButtonRootMode, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addGroup(layout.createSequentialGroup()
                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                                    .addGroup(layout.createSequentialGroup()
                                                                        .addComponent(jLabel1)
                                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                                        .addComponent(jTextFieldSearchClient, javax.swing.GroupLayout.PREFERRED_SIZE, 156, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                                                .addGap(18, 18, 18))
                                                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                                                .addComponent(jButtonNewClient)
                                                                .addGap(9, 9, 9)))
                                                        .addComponent(jTabbedWorkSystem)))
                                                .addContainerGap())
                                        );
                                        layout.setVerticalGroup(
                                            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addComponent(jButtonNewClient)
                                                        .addGap(18, 18, 18)
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                            .addComponent(jTextFieldSearchClient, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                            .addComponent(jLabel1))
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 367, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                        .addGap(0, 0, Short.MAX_VALUE))
                                                    .addComponent(jTabbedWorkSystem))
                                                .addGap(18, 18, 18)
                                                .addComponent(jButtonRootMode)
                                                .addContainerGap())
                                        );

                                        pack();
                                    }// </editor-fold>//GEN-END:initComponents

    private void jTableClientListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableClientListMouseClicked
        
            this.ableFields(false);
            DefaultTableModel model = (DefaultTableModel) jTableClientList.getModel();
            String name = (String) model.getValueAt(jTableClientList.getSelectedRow(), 0);
            
            this.searchClient(name);
            

        
    }//GEN-LAST:event_jTableClientListMouseClicked

    private void jTextFieldOrderNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldOrderNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldOrderNameActionPerformed

    private void jButtonOrderEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOrderEditActionPerformed
        if (client != null){
            
            this.ableFields(true);
            this.jButtonRootMode.setEnabled(true);
        }
    }//GEN-LAST:event_jButtonOrderEditActionPerformed

    private void jButtonOrderSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOrderSaveActionPerformed
        
        if (client != null){
            String name = jTextFieldOrderName.getText();
            String phone = jTextFieldOrderPhone.getText();

            clientControlled.editClient(client, new Client(name, phone));
            this.loadTableClientList();
            jButtonOrderSave.setEnabled(false);
        }
        
        client = null;
        this.ableFields(false);
        
    }//GEN-LAST:event_jButtonOrderSaveActionPerformed

    private void jButtonNewClientActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewClientActionPerformed
        NewClientForm newClient = new NewClientForm(this, true);
        newClient.setVisible(true);
        
        if (newClient.getClient() != null){
            clientControlled.addToList(newClient.getClient());
            this.loadTableClientList();
        }
    }//GEN-LAST:event_jButtonNewClientActionPerformed

    private void jButtonRootModeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRootModeActionPerformed
        jButtonRemove.setEnabled(true);
        
        this.jButtonRemoveProduct.setEnabled(true);
    }//GEN-LAST:event_jButtonRootModeActionPerformed
    
    private void jButtonNewProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNewProductActionPerformed
        
        NewProductForm newProduct = new NewProductForm(this, true, productControlled);
        newProduct.setVisible(true);
        
        this.loadTableProductList();
        
        
        
    }//GEN-LAST:event_jButtonNewProductActionPerformed

    private void jButtonEditProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonEditProductActionPerformed
               
        EditProductView editProduct = new EditProductView(this, true, product);
        editProduct.setVisible(true);
        
        this.loadTableProductList();
        this.loadTableOrder();
        
    }//GEN-LAST:event_jButtonEditProductActionPerformed
   
    
    private void jTableDishesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDishesMouseClicked
        
        loadDessertTable();
        loadDrinkTable();
        
        
        DefaultTableModel model = (DefaultTableModel) jTableDishes.getModel();
        String name = (String) model.getValueAt(jTableDishes.getSelectedRow(), 0);
            
        this.searchProduct(name);
        
        jButtonEditProduct.setEnabled(true);
        
    }//GEN-LAST:event_jTableDishesMouseClicked

    private void jTableDrinksMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDrinksMouseClicked
        loadDishTable();
        loadDessertTable();
        
        DefaultTableModel model = (DefaultTableModel) jTableDrinks.getModel();
        String name = (String) model.getValueAt(jTableDrinks.getSelectedRow(), 0);
            
        this.searchProduct(name);
        
        jButtonEditProduct.setEnabled(true);
    }//GEN-LAST:event_jTableDrinksMouseClicked

    private void jTableDessertsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDessertsMouseClicked
        loadDishTable();
        loadDrinkTable();
        
        DefaultTableModel model = (DefaultTableModel) jTableDesserts.getModel();
        String name = (String) model.getValueAt(jTableDesserts.getSelectedRow(), 0);
            
        this.searchProduct(name);
        
        jButtonEditProduct.setEnabled(true);
    }//GEN-LAST:event_jTableDessertsMouseClicked

    
    
    
            
    
    
    
    private void jTableDishesOrderMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDishesOrderMouseClicked
        this.loadDrinkOrderTable();
        this.loadDessertOrderTable();
        jButtonAddToOrder.setEnabled(true);
        
        DefaultTableModel model = (DefaultTableModel) jTableDishesOrder.getModel();
        String name = (String) model.getValueAt(jTableDishesOrder.getSelectedRow(), 0);
        this.searchProduct(name);
    }//GEN-LAST:event_jTableDishesOrderMouseClicked

    private void jTableDrinksOrderMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDrinksOrderMouseClicked
        this.loadDessertOrderTable();
        this.loadDishOrderTable();
        jButtonAddToOrder.setEnabled(true);
        
        DefaultTableModel model = (DefaultTableModel) jTableDrinksOrder.getModel();
        String name = (String) model.getValueAt(jTableDrinksOrder.getSelectedRow(), 0);
        this.searchProduct(name);
    }//GEN-LAST:event_jTableDrinksOrderMouseClicked

    private void jTableDessertsOrderMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableDessertsOrderMouseClicked
        this.loadDrinkOrderTable();
        this.loadDishOrderTable();
        jButtonAddToOrder.setEnabled(true);
        
        DefaultTableModel model = (DefaultTableModel) jTableDessertsOrder.getModel();
        String name = (String) model.getValueAt(jTableDessertsOrder.getSelectedRow(), 0);
        this.searchProduct(name);
    }//GEN-LAST:event_jTableDessertsOrderMouseClicked

    private void jTableOrderMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableOrderMouseClicked
        
    }//GEN-LAST:event_jTableOrderMouseClicked

    
    
    
    private void jButtonAddToOrderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddToOrderActionPerformed
        Integer subtotal = 0;
        jTableClientList.setEnabled(false);
        
        orderList.add(product);
        DefaultTableModel modelOrder = (DefaultTableModel) jTableOrder.getModel();
        modelOrder.setRowCount(0);
        
        if(modelOrder.getRowCount() != 0){
            jLabelOrderResume.setText(jLabelOrderResume.getText() + " Client " + jTextFieldOrderName.getText());
        }

        
        for (Product p :  orderList) {
            String id = null;
            switch(p.getId()){
                case 1:
                    id = "Dish";
                    break;
                case 2:
                    id = "Drink";
                    break;
                case 3:
                    id = "Dessert";
                    break;
                            
            }
            subtotal+= Integer.parseInt(p.getPrice());
            modelOrder.addRow(new String[]{id, p.getName(), "$" + p.getPrice()});
            
            
        }
        
        modelOrder.addRow(new String[]{"SUBTOTAL", "" , "$"+subtotal.toString()});
        jTableOrder.setModel(modelOrder);
        
    
    }//GEN-LAST:event_jButtonAddToOrderActionPerformed

    private void jButtonRemoveProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveProductActionPerformed
                
        switch (product.getId()){
            case 1:
                productControlled.removeFromDishList(product);
                this.loadDishTable();
                this.loadDishOrderTable();
                break;
            case 2:
                productControlled.removeFromDrinkList(product);
                this.loadDrinkTable();
                this.loadDrinkOrderTable();
                break;
            case 3:
                productControlled.removeFromDessertList(product);
                this.loadDessertTable();
                this.loadDessertOrderTable();
                break;
        }
        
       
    }//GEN-LAST:event_jButtonRemoveProductActionPerformed

    private void jButtonRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonRemoveActionPerformed
        clientControlled.removeFromList(client);
        this.loadTableClientList();
        this.cleanFields();
    }//GEN-LAST:event_jButtonRemoveActionPerformed

    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(EmployeeWorkSystem.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(EmployeeWorkSystem.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(EmployeeWorkSystem.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(EmployeeWorkSystem.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new EmployeeWorkSystem(employeeLogged).setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAddToOrder;
    private javax.swing.JButton jButtonEditProduct;
    private javax.swing.JButton jButtonNewClient;
    private javax.swing.JButton jButtonNewProduct;
    private javax.swing.JButton jButtonOrderEdit;
    private javax.swing.JButton jButtonOrderSave;
    private javax.swing.JButton jButtonRemove;
    private javax.swing.JButton jButtonRemoveProduct;
    private javax.swing.JButton jButtonRootMode;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelOrderResume;
    private javax.swing.JPanel jPanelNewOrder;
    private javax.swing.JPanel jPanelProductManagement;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTabbedPane jTabbedWorkSystem;
    private javax.swing.JTable jTableClientList;
    private javax.swing.JTable jTableDesserts;
    private javax.swing.JTable jTableDessertsOrder;
    private javax.swing.JTable jTableDishes;
    private javax.swing.JTable jTableDishesOrder;
    private javax.swing.JTable jTableDrinks;
    private javax.swing.JTable jTableDrinksOrder;
    private javax.swing.JTable jTableOrder;
    private javax.swing.JTextField jTextFieldOrderName;
    private javax.swing.JTextField jTextFieldOrderPhone;
    private javax.swing.JTextField jTextFieldSearchClient;
    // End of variables declaration//GEN-END:variables


    private void loadTableClientList() {
        
        ArrayList<Client> clientList = clientControlled.getListClients();
        DefaultTableModel model = (DefaultTableModel) jTableClientList.getModel();
        model.setRowCount(0);
        
        for (Client b : clientList) {
            model.addRow(new String[]{b.getName()});
        }
        jTableClientList.setModel(model);
        jTableClientList.setVisible(true);
    }
    
    
    private void loadTableProductList(){
        loadDishTable();
        loadDrinkTable();
        loadDessertTable();
        
    }
    
    public void loadTableOrder(){
        this.loadDessertOrderTable();
        this.loadDrinkOrderTable();
        this.loadDishOrderTable();
    }
    
    private void loadDishTable(){
        ArrayList<Product> dishList = productControlled.getDishList();
        DefaultTableModel modelDish = (DefaultTableModel) jTableDishes.getModel();
        modelDish.setRowCount(0);
        
        for (Product p :  dishList) {
            modelDish.addRow(new String[]{p.getName(), p.getAmmount().toString()});
        }
        
        jTableDishes.setModel(modelDish);
        jTableDishes.setVisible(true);
                
    }
   
    private void loadDrinkTable(){
        ArrayList<Product> drinkList = productControlled.getDrinkList();
        DefaultTableModel modelDrink = (DefaultTableModel) jTableDrinks.getModel();
        modelDrink.setRowCount(0);
        
        for (Product p :  drinkList) {
            modelDrink.addRow(new String[]{p.getName(), p.getAmmount().toString()});
        }
        
        jTableDrinks.setModel(modelDrink);
        jTableDrinks.setVisible(true);
        
    }
   
    private void loadDessertTable() {
  
        ArrayList<Product> dessertList = productControlled.getDessertList();
        DefaultTableModel modelDessert = (DefaultTableModel) jTableDesserts.getModel();
        modelDessert.setRowCount(0);
        
        
        
        for (Product p :  dessertList) {
            modelDessert.addRow(new String[]{p.getName(), p.getAmmount().toString()});
        }
        
        
        jTableDesserts.setModel(modelDessert);
        jTableDesserts.setVisible(true);
    }
    
    private void loadDessertOrderTable() {
  
        ArrayList<Product> dessertList = productControlled.getDessertList();
        DefaultTableModel modelDessert = (DefaultTableModel) jTableDessertsOrder.getModel();
        modelDessert.setRowCount(0);
        
        
        
        for (Product p :  dessertList) {
            modelDessert.addRow(new String[]{p.getName()});
        }
        
        
        jTableDessertsOrder.setModel(modelDessert);
        jTableDessertsOrder.setVisible(true);
    }
    
    private void loadDrinkOrderTable() {
  
        ArrayList<Product> drinkList = productControlled.getDrinkList();
        DefaultTableModel modelDrink = (DefaultTableModel) jTableDrinksOrder.getModel();
        modelDrink.setRowCount(0);
        
        
        
        for (Product p :  drinkList) {
            modelDrink.addRow(new String[]{p.getName()});
        }
        
        
        jTableDrinksOrder.setModel(modelDrink);
        jTableDrinksOrder.setVisible(true);
    }

    private void loadDishOrderTable() {
  
        ArrayList<Product> dishList = productControlled.getDishList();
        DefaultTableModel modelDish = (DefaultTableModel) jTableDishesOrder.getModel();
        modelDish.setRowCount(0);
        
        
        
        for (Product p :  dishList) {
            modelDish.addRow(new String[]{p.getName()});
        }
        
        
        jTableDishesOrder.setModel(modelDish);
        jTableDishesOrder.setVisible(true);
    }
    
    private void searchClient(String name) {
        
        client = clientControlled.searchClient(name);
        this.fullFields(client);
        
    }
    
    private void searchProduct(String name){
        product = productControlled.searchProduct(name);
    }

    private void fullFields(Client client) {
        this.jTextFieldOrderName.setText(client.getName());
        this.jTextFieldOrderPhone.setText(client.getPhone());
    }
    
    private void ableFields(boolean b){
        
        
        jTextFieldOrderName.setEnabled(b);
        jTextFieldOrderPhone.setEnabled(b);
        jButtonOrderSave.setEnabled(b);
        
        jButtonRemove.setEnabled(false);
     
        jButtonRootMode.setEnabled(false);
        
        jPanelProductManagement.setVisible(false);
        
        jButtonNewClient.setVisible(false);
        jButtonEditProduct.setEnabled(false);
        
        jButtonAddToOrder.setEnabled(false);
        
        
    }

    private void cleanFields() {
        jTextFieldOrderName.setText("");
        jTextFieldOrderPhone.setText("");
    }
  
}
